/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *  Neuste Version: http://www.mikrocontroller.net/svnbrowser/avr-fat32/
 *	Autor: Daniel R.
 */

#include <stdlib.h>
#include <avr/io.h>

#include "config.h" 	// Hier werden alle nötigen Konfigurationen vorgenommen !
#include "file.h"
#include "fat.h"
#include "mmc.h"		// Hardware abhängig.
#include "uart.h"		// Hardware abhängig, es kann auch eine eigene eingebunden werden !


//*****************************************************************************************************************
void main(void){

	// Uart initialisierung zu Ausgabe von Daten.
	uinit();

	uputs((unsigned char*)"\nBoot");

	// Versuch Karte zu Initialisieren, bis es klappt.
	// Umbedingt so, weil die Initialiesierung nicht immer auf anhieb klappt.
	while (FALSE==mmc_init()){
		nop();
	}

	uputs((unsigned char*)"...");


	// Fat initialisieren. Nur wenn das klappt sind weitere Aktionen sinnvoll, sonst aendet das Programm !
	if(TRUE == fat_loadFatData()){

	  // Wenn auf dem terminal "Boot... OK" zu lesen ist, ist Init OK.
	  // Jetzt kann man schreiben/anhaengen/lesen.
	  uputs((unsigned char*)"Ok\n");



	  // Dateinamen muessen in diesem Format sein !
	  // Man beachte die Größe des Arrays und die Großbuchstaben!
	  unsigned char file_name[9]="test.txt";

// Wenn MMC_WRITE FALSE in der config.h gesetzt ist, wird nur gelesen.
#if (MMC_WRITE==TRUE)

	  // String zum in die Datei schreiben.
	  unsigned char str[13]="Hallo Datei!";




	  // Datei existiert nicht, also anlegen !
	  // Die Datei TEST.TXT war noch nicht auf der Karte vorhanden !
	  if(MMC_FILE_NEW == ffopen(file_name)){

	     // Schreibt String auf Karte !
		 // Nur richtige Strings koennen mit ffwrites geschrieben werden !
	     ffwrites(str);

	     // Neue Zeile in der Datei.
	     // Schreibt Zeilenumbruch in die Text Datei.
	     ffwrite(0x0D);
	     ffwrite(0x0A);

	     // Schließt Datei.
	     ffclose();
	   }
#endif

/*

	  // Datei existiert, also anhaengen !
	  // Wurde entweder grade angelegt, oder war schon vorhanden.
	  if(MMC_FILE_EXISTS == ffopen(file_name)){

		 // Spult bis zum Dateiende vor um anzuhaengen, geht auch ohne Option MMC_OVER_WRITE !
	     ffseek(file.length);

	     // Schreibt String.
	     ffwrites(str);

	     // Neue Zeile in der Datei.
	     // Schreibt Zeilenumbruch in die Text Datei.
	     ffwrite(0x0D);
	     ffwrite(0x0A);

	     // Schließt Datei.
	     ffclose();
	   }

#endif


	   // Datei existiert also lesen.
	   // Gerade angelegt und beschrieben, oder war schon vorhanden und es wurde was angehaengt.
	   // Wenn MMC_WRITE FALSE in der config.h gesetzt ist, wird nur gelesen.
	   if(MMC_FILE_EXISTS == ffopen(file_name)){

	      // Setzen einer Variable und dann runterzaehlen geht am schnellsten !
	      unsigned long int seek=file.length;

	      // Lesen eines chars und Ausgabe des chars.
	      // Solange bis komplette Datei gelesen wurde.
	      do{
	         uputc(ffread());
	      }while(--seek);

	      ffclose();
	   }
*/



	}

}
